
(* override with a specialized version *)
fun OBTAIN elim_tac prems tac i ctx thm =
  let fun fail () =
        error ("OBTAIN works only on focussed goals, have:\n"^
               Syntax.string_of_term ctx (term_of (cprem_of thm i)))
      fun check_prems () =
        case term_of (cprem_of thm i) of
            Const("all",_) $ _ => fail()
          | Const("==>",_) $ _ $ _ => fail()
          | _ => ()
  in
      SELECT_GOAL
      (cut_facts_tac prems 1 THEN
       elim_tac ctx THEN
       Subgoal.FOCUS_PREMS
        (fn {context,params,prems,...} => tac context params prems) ctx 1) 
      i thm
  end

